<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RemoteException StructType
 * @subpackage Structs
 */
class RemoteException extends IOException
{
    /**
     * The RemoteException
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RemoteException
     */
    public $RemoteException;
    /**
     * The cause
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var mixed
     */
    public $cause;
    /**
     * The message
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $message;
    /**
     * Constructor method for RemoteException
     * @uses RemoteException::setRemoteException()
     * @uses RemoteException::setCause()
     * @uses RemoteException::setMessage()
     * @param \StructType\RemoteException $remoteException
     * @param mixed $cause
     * @param string $message
     */
    public function __construct(\StructType\RemoteException $remoteException = null, $cause = null, $message = null)
    {
        $this
            ->setRemoteException($remoteException)
            ->setCause($cause)
            ->setMessage($message);
    }
    /**
     * Get RemoteException value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RemoteException|null
     */
    public function getRemoteException()
    {
        return isset($this->RemoteException) ? $this->RemoteException : null;
    }
    /**
     * Set RemoteException value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\RemoteException $remoteException
     * @return \StructType\RemoteException
     */
    public function setRemoteException(\StructType\RemoteException $remoteException = null)
    {
        if (is_null($remoteException) || (is_array($remoteException) && empty($remoteException))) {
            unset($this->RemoteException);
        } else {
            $this->RemoteException = $remoteException;
        }
        return $this;
    }
    /**
     * Get cause value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return mixed|null
     */
    public function getCause()
    {
        return isset($this->cause) ? $this->cause : null;
    }
    /**
     * Set cause value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param mixed $cause
     * @return \StructType\RemoteException
     */
    public function setCause($cause = null)
    {
        if (is_null($cause) || (is_array($cause) && empty($cause))) {
            unset($this->cause);
        } else {
            $this->cause = $cause;
        }
        return $this;
    }
    /**
     * Get message value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMessage()
    {
        return isset($this->message) ? $this->message : null;
    }
    /**
     * Set message value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $message
     * @return \StructType\RemoteException
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($message)), __LINE__);
        }
        if (is_null($message) || (is_array($message) && empty($message))) {
            unset($this->message);
        } else {
            $this->message = $message;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RemoteException
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
